﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Insigma.ProjectQuote.Model;
using Insigma.ProjectQuote.DAL;

namespace Insigma.ProjectQuote.BLL
{
    public partial class ProjectItemManager
    {
        /// <summary>
        /// 项目信息修改前进行验证
        /// </summary>
        /// <param name="projectItem"></param>
        /// <returns></returns>
        public bool UpdateThroughChecked(ProjectItem projectItem)
        {
            if (string.IsNullOrEmpty(projectItem._Project.ProjectName))
            {
                throw new Exception("项目名称不能为空");
            }
            //顾客姓名可以为空，但联系人不能为空，所以数据库里就应该设计好
            if (string.IsNullOrEmpty(projectItem._Project.Contact))
            {
                throw new Exception("联系人姓名不能为空");
            }
            if (string.IsNullOrEmpty(projectItem._Project.Tel))
            {
                throw new Exception("联系电话不能为空");
            }
            if (string.IsNullOrEmpty(projectItem._Project.DeliveryPlace))
            {
                throw new Exception("交货地点不能为空");
            }
            if (string.IsNullOrEmpty(projectItem._Project.DeliveryTime))
            {
                throw new Exception("交货时间不能为空");
            }
            if (projectItem._Project.TransportCosts<00)
            {
                throw new Exception("运输费用不能为负数");
            }
            return new DAL.ProjectItemService().UpdatePassChecked(projectItem) > 0;

        }
        public ProjectItem GetProjectByID(int iD)
        {
            return new ProjectItemService().GetProjectByID(iD);
        }
        //public bool AddProjectItem(int projectID,int productID,string unitPrice,string count)
        //{
        //    decimal dUnitPrice = 0.00M;
        //    int iCount = 0;
        //    try
        //    {
        //        dUnitPrice = decimal.Parse(unitPrice);
        //    }
        //    catch 
        //    {
        //        throw new Exception("单价格式有误");
        //    }

        //}
        public Model.ProjectItem AddProjectItem(Model.ProjectItem model)
        {
            return new DAL.ProjectItemService().Add(model);
        }
        public IEnumerable<ProjectItem> GetAllProducts(int projectID)
        {
            return new DAL.ProjectItemService().GetAllProducts(projectID);
        }
        public bool DeleteProjectItemsByProjectID(int projectID)
        {
            return new DAL.ProjectItemService().DeleteProjectItemsByProjectID(projectID)>0;
        }

        public decimal GetProductTotalMoney(int projectID)
        {
            var list = new DAL.ProjectItemService().GetProductTotalMoney(projectID);
            decimal  totalMoney = 0.00M;
            foreach (var model in list)
            {
                totalMoney+=model.TotalMoney.Value;
            }
            return totalMoney;
        }
        //public bool DeleteProjectItemsByProjectID(int projectID)
        //{
        //    return new DAL.ProjectItemService().DeleteProjectItemsByProjectID(projectID)>0;
        //}

        //public decimal GetProjectTransportCosts(int projectID)
        //{
        //    var model = new DAL.ProjectItemService().GetProjectTotalMoney(proj);
        //}

        //根据项目删除项目相关的产品
        //public bool DeleteProjectItemsByProjectID()
        //{ 
            
        //}
        public Model.ProjectItem GetOneProjectItemByID(int ProjectItemID)
        {
            return new DAL.ProjectItemService().GetOneProjectItemByID(ProjectItemID);
        }
    }
}
