﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Insigma.ProjectQuote.BLL
{
    public partial class ProjectManager
    {
        public IEnumerable<Model.Project> GetProjectByCondition(string projectName, string customerName, string contract, string tel)
        {
            return new DAL.ProjectService().GetProjectByCondition(projectName, customerName, contract, tel);
        }
        /// <summary>
        /// 删除一个项目
        /// </summary>
        /// <param name="projectID"></param>
        /// <returns></returns>
        public bool DeleteProject(int projectID)
        {
             bool isSucceed=  new BLL.ProjectItemManager().DeleteProjectItemsByProjectID(projectID);
             isSucceed = new DAL.ProjectService().DeleteByID(projectID) > 0 && isSucceed;
             return isSucceed;
        }

        /// <summary>
        /// 新增一条记录 根据条件
        /// </summary>
        /// <param name="modelProject"></param>
        /// <returns></returns>
        public Model.Project AddPassCheckd(Model.Project modelProject)
        {
            //我还是看一下老子封装出来的东西是什么？modelProject.ProjectName==""呢还是NULL
            if (string.IsNullOrEmpty(modelProject.ProjectName))
            {
                throw new Exception("项目名称不能为空");
            }
            if (string.IsNullOrEmpty(modelProject.Customer))
            {
                throw new Exception("顾客名称不能为空");
            }
            if (string.IsNullOrEmpty(modelProject.Tel))
            {
                throw new Exception("联系电话不能为空");
            }
            if (modelProject.TransportCosts <= 0)
            {
                throw new Exception("运输费用不能为负数:(");
            }
            return new DAL.ProjectService().Add(modelProject);
           
        }
      
    }
}
