﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;
using Insigma.ProjectQuote.Model;

namespace Insigma.ProjectQuote.DAL
{
    public partial class ProductService
    {
        //请等待：,string priceLow,string priceHigh
        public IEnumerable<Model.Product> GetProductsByCondition(string productName,string manufacturer,string specification,string parameters)
        {
             StringBuilder sqlWhere=new StringBuilder ("select * from Product where 1=1");
             List<SqlParameter> listParameters = new List<SqlParameter>();
            if (!string.IsNullOrWhiteSpace(productName))
            {
                sqlWhere.AppendLine(" and ProductName like @ProductName");
                listParameters.Add(new SqlParameter("ProductName","%"+productName+"%"));
            }
            if (!string.IsNullOrWhiteSpace(manufacturer))
            {
                sqlWhere.AppendLine(" and Manufacturer like @Manufacturer");
                listParameters.Add(new SqlParameter("Manufacturer","%"+manufacturer+"%"));
            }
            if (!string.IsNullOrWhiteSpace(specification))
            {
                sqlWhere.AppendLine(" and Specification like @Specification");
                listParameters.Add(new SqlParameter("Specification","%"+specification+"%"));
            }
            if (!string.IsNullOrWhiteSpace(parameters))
            {
                sqlWhere.AppendLine(" and Parameters like @Parameters");
                listParameters.Add(new SqlParameter("Parameters","%"+parameters+"%"));
            }
            using (SqlDataReader reader=SqlHelper.ExecuteDataReader(sqlWhere.ToString(),listParameters.ToArray()))
            {
                return ToModels(reader);
            }
            
        }
        /// <summary>
        /// 根据查询条件获取数据集合--方法的重载
        /// </summary>
        /// <param name="id"></param>
        /// <returns></returns>
        public IEnumerable<Model.Product> GetProductsByCondition(string condition)
        {
            
            StringBuilder sbSql = new StringBuilder("select * from Product where 1=1");
            sbSql.AppendLine(" And ( ProductName like @ProductName Or Manufacturer like @Manufacturer Or  Specification like @Specification Or Parameters like @Parameters )");
            SqlParameter[] parameters ={
                                      new SqlParameter("ProductName","%"+condition+"%"),
                                      new SqlParameter("Manufacturer","%"+condition+"%"),
                                      new SqlParameter("Specification","%"+condition+"%"),
                                      new SqlParameter("Parameters","%"+condition+"%")
                                      };
            using (SqlDataReader reader=SqlHelper.ExecuteDataReader(sbSql.ToString(),parameters))
            {
                return ToModels(reader);
            }

        }

        
    }
}
