//============================================================
//http://OceanEyes.cnblogs.com
//============================================================

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using Insigma.ProjectQuote.Model;

namespace Insigma.ProjectQuote.DAL
{
	public partial class ProjectItemService
	{
        public ProjectItem Add
			(ProjectItem projectItem)
		{
				string sql ="INSERT INTO ProjectItem (ProjectID, ProductID, UnitPrice, Count, TotalMoney)  output inserted.ID VALUES (@ProjectID, @ProductID, @UnitPrice, @Count, @TotalMoney)";
				
                SqlParameter[] para = new SqlParameter[]
					{
						new SqlParameter("@ProjectID", ToDBValue(projectItem._Project.ID)),
						new SqlParameter("@ProductID", ToDBValue(projectItem._Product.ID)),
						new SqlParameter("@UnitPrice", ToDBValue(projectItem.UnitPrice)),
						new SqlParameter("@Count", ToDBValue(projectItem.Count)),
						new SqlParameter("@TotalMoney", ToDBValue(projectItem.TotalMoney)),
					};
					
				int newId = (int)SqlHelper.ExecuteScalar(sql, para);
				return GetByID(newId);
		}

        public int DeleteByID(int iD)
		{
            string sql = "DELETE ProjectItem WHERE ID = @ID";

           SqlParameter[] para = new SqlParameter[]
			{
				new SqlParameter("@ID", iD)
			};
		
            return SqlHelper.ExecuteNonQuery(sql, para);
		}
		
				
        public int Update(ProjectItem projectItem)
        {
            string sql =
                "UPDATE ProjectItem " +
                "SET " +
			" ProjectID = @ProjectID" 
                +", ProductID = @ProductID" 
                +", UnitPrice = @UnitPrice" 
                +", Count = @Count" 
                +", TotalMoney = @TotalMoney" 
               
            +" WHERE ID = @ID";


			SqlParameter[] para = new SqlParameter[]
			{
				new SqlParameter("@ID", projectItem.ID)
					,new SqlParameter("@ProjectID", ToDBValue(projectItem._Project.ID))
					,new SqlParameter("@ProductID", ToDBValue(projectItem._Product.ID))
					,new SqlParameter("@UnitPrice", ToDBValue(projectItem.UnitPrice))
					,new SqlParameter("@Count", ToDBValue(projectItem.Count))
					,new SqlParameter("@TotalMoney", ToDBValue(projectItem.TotalMoney))
			};

			return SqlHelper.ExecuteNonQuery(sql, para);
        }		
		
        public ProjectItem GetByID(int iD)
        {
            string sql = "SELECT * FROM ProjectItem WHERE ID = @ID";
            using(SqlDataReader reader = SqlHelper.ExecuteDataReader(sql, new SqlParameter("@ID", iD)))
			{
				if (reader.Read())
				{
					return ToModel(reader);
				}
				else
				{
					return null;
				}
       		}
        }
		
		public ProjectItem ToModel(SqlDataReader reader)
		{
			ProjectItem projectItem = new ProjectItem();
            projectItem._Product = new Product();
            projectItem._Project = new Project();
			projectItem.ID = (int)ToModelValue(reader,"ID");
            projectItem._Project.ID = (int)ToModelValue(reader, "ProjectID");
            projectItem._Product.ID = (int)ToModelValue(reader, "ProductID");//Pacial д ...Customer into ..Sql id=id;
            //projectItem.ProjectID = (int?)ToModelValue(reader,"ProjectID");
            //projectItem.ProductID = (int?)ToModelValue(reader,"ProductID");
			projectItem.UnitPrice = (decimal?)ToModelValue(reader,"UnitPrice");
			projectItem.Count = (int?)ToModelValue(reader,"Count");
			projectItem.TotalMoney = (decimal?)ToModelValue(reader,"TotalMoney");
			return projectItem;
		}
		
		public int GetTotalCount()
		{
			string sql = "SELECT count(*) FROM ProjectItem";
			return (int)SqlHelper.ExecuteScalar(sql);
		}
		
		public IEnumerable<ProjectItem> GetPagedData(int minrownum,int maxrownum)
		{
			string sql = "SELECT * from(SELECT *,(row_number() over(order by ID))-1 rownum FROM ProjectItem) t where rownum>=@minrownum and rownum<=@maxrownum";
			using(SqlDataReader reader = SqlHelper.ExecuteDataReader(sql,
				new SqlParameter("@minrownum",minrownum),
				new SqlParameter("@maxrownum",maxrownum)))
			{
				return ToModels(reader);					
			}
		}
		
		public IEnumerable<ProjectItem> GetAll()
		{
			string sql = "SELECT * FROM ProjectItem";
			using(SqlDataReader reader = SqlHelper.ExecuteDataReader(sql))
			{
				return ToModels(reader);			
			}
		}
		
		protected IEnumerable<ProjectItem> ToModels(SqlDataReader reader)
		{
			var list = new List<ProjectItem>();
			while(reader.Read())
			{
				list.Add(ToModel(reader));
			}	
			return list;
		}		
		
		protected object ToDBValue(object value)
		{
			if(value==null)
			{
				return DBNull.Value;
			}
			else
			{
				return value;
			}
		}
		
		protected object ToModelValue(SqlDataReader reader,string columnName)
		{
			if(reader.IsDBNull(reader.GetOrdinal(columnName)))
			{
				return null;
			}
			else
			{
				return reader[columnName];
			}
		}
	}
}
