﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
namespace Insigma.ProjectQuote.DAL
{
    public partial class ProjectService
    {

        public IEnumerable<Model.Project> GetProjectByCondition(string projectName, string customerName, string contract, string tel)
        {
            StringBuilder sqlWhere = new StringBuilder("select * from Project where 1=1");
            List<SqlParameter> listParameters = new List<SqlParameter>();
            if (!string.IsNullOrWhiteSpace(projectName))
            {
                sqlWhere.AppendLine(" and projectName like @projectName");
                listParameters.Add(new SqlParameter("projectName", "%" + projectName + "%"));
            }
            if (!string.IsNullOrWhiteSpace(contract))
            {
                sqlWhere.AppendLine(" and Contact like @Contact");
                listParameters.Add(new SqlParameter("Contact", "%" + contract + "%"));
            }
            if (!string.IsNullOrWhiteSpace(customerName))
            {
                sqlWhere.AppendLine(" and customer like @customer");
                listParameters.Add(new SqlParameter("customer", "%" + customerName + "%"));
            }
            if (!string.IsNullOrWhiteSpace(tel))
            {
                sqlWhere.AppendLine(" and tel like @tel");
                listParameters.Add(new SqlParameter("tel", "%" + tel + "%"));
            }
            using (SqlDataReader reader = SqlHelper.ExecuteDataReader(sqlWhere.ToString(), listParameters.ToArray()))
            {
                return ToModels(reader);
            }

        }
        /// <summary>
        /// 删除项目关联的产品
        /// </summary>
        /// <param name="projectID"></param>
        /// <returns></returns>

    }
}
