//============================================================
//http://OceanEyes.cnblogs.com
//============================================================

using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using Insigma.ProjectQuote.Model;

namespace Insigma.ProjectQuote.DAL
{
	public partial class ProjectService
	{
        public Project Add
			(Project project)
		{
				string sql ="INSERT INTO Project (ProjectName, Customer, Contact, Tel, DeliveryPlace, DeliveryTime, TransportCosts, PaymentTerm, Bak)  output inserted.ID VALUES (@ProjectName, @Customer, @Contact, @Tel, @DeliveryPlace, @DeliveryTime, @TransportCosts, @PaymentTerm, @Bak)";
				SqlParameter[] para = new SqlParameter[]
					{
						new SqlParameter("@ProjectName", ToDBValue(project.ProjectName)),
						new SqlParameter("@Customer", ToDBValue(project.Customer)),
						new SqlParameter("@Contact", ToDBValue(project.Contact)),
						new SqlParameter("@Tel", ToDBValue(project.Tel)),
						new SqlParameter("@DeliveryPlace", ToDBValue(project.DeliveryPlace)),
						new SqlParameter("@DeliveryTime", ToDBValue(project.DeliveryTime)),
						new SqlParameter("@TransportCosts", ToDBValue(project.TransportCosts)),
						new SqlParameter("@PaymentTerm", ToDBValue(project.PaymentTerm)),
						new SqlParameter("@Bak", ToDBValue(project.Bak)),
					};
					
				int newId = (int)SqlHelper.ExecuteScalar(sql, para);
               //п-ʧ NULL -- -1;
				return GetByID(newId);
		}

        public int DeleteByID(int iD)
		{
            string sql = "DELETE Project WHERE ID = @ID";

           SqlParameter[] para = new SqlParameter[]
			{
				new SqlParameter("@ID", iD)
			};
		
            return SqlHelper.ExecuteNonQuery(sql, para);
		}
		
				
        public int Update(Project project)
        {
            string sql =
                "UPDATE Project " +
                "SET " +
			" ProjectName = @ProjectName" 
                +", Customer = @Customer" 
                +", Contact = @Contact" 
                +", Tel = @Tel" 
                +", DeliveryPlace = @DeliveryPlace" 
                +", DeliveryTime = @DeliveryTime" 
                +", TransportCosts = @TransportCosts" 
                +", PaymentTerm = @PaymentTerm" 
                +", Bak = @Bak" 
               
            +" WHERE ID = @ID";


			SqlParameter[] para = new SqlParameter[]
			{
				new SqlParameter("@ID", project.ID)
					,new SqlParameter("@ProjectName", ToDBValue(project.ProjectName))
					,new SqlParameter("@Customer", ToDBValue(project.Customer))
					,new SqlParameter("@Contact", ToDBValue(project.Contact))
					,new SqlParameter("@Tel", ToDBValue(project.Tel))
					,new SqlParameter("@DeliveryPlace", ToDBValue(project.DeliveryPlace))
					,new SqlParameter("@DeliveryTime", ToDBValue(project.DeliveryTime))
					,new SqlParameter("@TransportCosts", ToDBValue(project.TransportCosts))
					,new SqlParameter("@PaymentTerm", ToDBValue(project.PaymentTerm))
					,new SqlParameter("@Bak", ToDBValue(project.Bak))
			};

			return SqlHelper.ExecuteNonQuery(sql, para);
        }		
		
        public Project GetByID(int iD)
        {
            string sql = "SELECT * FROM Project WHERE ID = @ID";
            using(SqlDataReader reader = SqlHelper.ExecuteDataReader(sql, new SqlParameter("@ID", iD)))
			{
				if (reader.Read())
				{
					return ToModel(reader);
				}
				else
				{
					return null;
				}
       		}
        }
		
		public Project ToModel(SqlDataReader reader)
		{
			Project project = new Project();

			project.ID = (int)ToModelValue(reader,"ID");
			project.ProjectName = (string)ToModelValue(reader,"ProjectName");
			project.Customer = (string)ToModelValue(reader,"Customer");
			project.Contact = (string)ToModelValue(reader,"Contact");
			project.Tel = (string)ToModelValue(reader,"Tel");
			project.DeliveryPlace = (string)ToModelValue(reader,"DeliveryPlace");
			project.DeliveryTime = (string)ToModelValue(reader,"DeliveryTime");
			project.TransportCosts = (decimal?)ToModelValue(reader,"TransportCosts");
			project.PaymentTerm = (string)ToModelValue(reader,"PaymentTerm");
			project.Bak = (string)ToModelValue(reader,"Bak");
			return project;
		}
		
		public int GetTotalCount()
		{
			string sql = "SELECT count(*) FROM Project";
			return (int)SqlHelper.ExecuteScalar(sql);
		}
		
		public IEnumerable<Project> GetPagedData(int minrownum,int maxrownum)
		{
			string sql = "SELECT * from(SELECT *,(row_number() over(order by ID))-1 rownum FROM Project) t where rownum>=@minrownum and rownum<=@maxrownum";
			using(SqlDataReader reader = SqlHelper.ExecuteDataReader(sql,
				new SqlParameter("@minrownum",minrownum),
				new SqlParameter("@maxrownum",maxrownum)))
			{
				return ToModels(reader);					
			}
		}
		
		public IEnumerable<Project> GetAll()
		{
			string sql = "SELECT * FROM Project";
			using(SqlDataReader reader = SqlHelper.ExecuteDataReader(sql))
			{
				return ToModels(reader);			
			}
		}
		
		protected IEnumerable<Project> ToModels(SqlDataReader reader)
		{
			var list = new List<Project>();
			while(reader.Read())
			{
				list.Add(ToModel(reader));
			}	
			return list;
		}		
		
		protected object ToDBValue(object value)
		{
			if(value==null)
			{
				return DBNull.Value;
			}
			else
			{
				return value;
			}
		}
		
		protected object ToModelValue(SqlDataReader reader,string columnName)
		{
			if(reader.IsDBNull(reader.GetOrdinal(columnName)))
			{
				return null;
			}
			else
			{
				return reader[columnName];
			}
		}
	}
}
