﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Insigma.ProjectQuote.WinUI
{
    // 然后就是初始化
    //添加一条记录后转至这张页面，所以进来时文本框全部不能写
    public partial class ProjectItemListForm : Form
    {
        public int projectID = -1;
        Model.ProjectItem model = null;
        public ProjectItemListForm()
        {
            InitializeComponent();
            dataGridViewProjectItems.AutoGenerateColumns = false;

        }
        void LoadData()
        {
            var list = new BLL.ProjectItemManager().GetAllProducts(projectID);
            //dataGridViewProjectItems.DataSource = list;//当控件被绑定时无法向其添加Row
            dataGridViewProjectItems.Rows.Clear();
            foreach (var model in list)
            {
                int i = dataGridViewProjectItems.Rows.Add();
                dataGridViewProjectItems.Rows[i].Cells["idColumn"].Value = model.ID;
                dataGridViewProjectItems.Rows[i].Cells["specificationColumn"].Value = model._Product.Specification;
                dataGridViewProjectItems.Rows[i].Cells["productNameColumn"].Value = model._Product.ProductName;
                dataGridViewProjectItems.Rows[i].Cells["manufacturerColumn"].Value = model._Product.Manufacturer;
                dataGridViewProjectItems.Rows[i].Cells["parametersColumn"].Value = model._Product.Parameters;
                dataGridViewProjectItems.Rows[i].Cells["productIDColumn"].Value = model._Product.ID;
                dataGridViewProjectItems.Rows[i].Cells["totalMoneyColumn"].Value = model.TotalMoney;
                dataGridViewProjectItems.Rows[i].Cells["countColumn"].Value = model.Count;
                dataGridViewProjectItems.Rows[i].Cells["unitPriceColumn"].Value = model.UnitPrice;
                dataGridViewProjectItems.Rows[i].Cells["projectIDColumn"].Value = model._Project.ID;
            }
        }
        private void ProjectItemListForm_Load(object sender, EventArgs e)
        {
            LoadData();
            LoadMoney();
            //Model.ProjectItem model = new Model.ProjectItem();
            //dataGridViewProjectItems.AutoGenerateColumns = false;
            model = new BLL.ProjectItemManager().GetProjectByID(projectID);
            txtProjectName.Text = model._Project.ProjectName;
            txtCustomer.Text = model._Project.Customer;
            txtContact.Text = model._Project.Contact;
            txtDeliveryPlace.Text = model._Project.DeliveryPlace;
            txtPaymentTerm.Text = model._Project.PaymentTerm;
            txtProjectName.Text = model._Project.ProjectName;
            txtTel.Text = model._Project.Tel;
            txtBak.Text = model._Project.Bak;
            txtTransportCosts.Text = model._Project.TransportCosts.ToString();
        }
        public void SetControlsEnable()
        {
            txtBak.ReadOnly = false;
            txtContact.ReadOnly = false;
            txtCustomer.ReadOnly = false;
            txtDeliveryPlace.ReadOnly = false;
            txtPaymentTerm.ReadOnly = false;
            txtProjectName.ReadOnly = false;
            txtTel.ReadOnly = false;
            txtTransportCosts.ReadOnly = false;
            //dataGridView1.Enabled = true;
            btnOK.Text = "保存";
        }
        public void SetControlsDisable()
        {
            txtBak.ReadOnly = true;
            txtContact.ReadOnly = true;
            txtCustomer.ReadOnly = true;
            txtDeliveryPlace.ReadOnly = true;
            txtPaymentTerm.ReadOnly = true;
            txtProjectName.ReadOnly = true;
            txtTel.ReadOnly = true;
            txtTransportCosts.ReadOnly = true;
            //dataGridView1.Enabled = false;
            btnOK.Text = "修改项目信息";
        }
        private void btnOK_Click(object sender, EventArgs e)
        {
            //点击它 控件可以修改 文本变保存 之后保存在后再变灰色
            if (btnOK.Text=="修改项目信息")
            {
                SetControlsEnable();
            }
            else
            {
                //保存
                //使用有异常抛出的方法时必须要try---Catch
                //UI少点判读 直接BLL搞定
                //就截断二进制...哪儿出来的

                model._Project.PaymentTerm = txtPaymentTerm.Text.Trim();
                model._Project.ID = projectID;
                model._Project.ProjectName = txtProjectName.Text.Trim();
                model._Project.Tel = txtTel.Text.Trim();
                model._Project.TransportCosts = decimal.Parse(txtTransportCosts.Text);
                model._Project.DeliveryTime = dtpRecevier.Value.ToString();
                model._Project.DeliveryPlace = txtDeliveryPlace.Text;
                model._Project.Customer = txtCustomer.Text;
                model._Project.Contact = txtContact.Text;
                model._Project.Bak = txtBak.Text;
                try
                {
                    if (new BLL.ProjectItemManager().UpdateThroughChecked(model))
                    {
                        MessageBox.Show("更新成功");
                        LoadMoney(); 
                        SetControlsDisable();
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
        }
        /// <summary>
        /// 新增产品
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            //新增项目产品
            AddProjectItemForm addProjectItemForm = new AddProjectItemForm();
            addProjectItemForm.ProjectID = projectID;
            if (addProjectItemForm.ShowDialog()==DialogResult.OK)
            {
                LoadData();
                //loadProjectItem();
                //var list = new BLL.ProjectItemManager().GetAllProducts(projectID);
                //dataGridViewProjectItems.DataSource = (List<Model.ProjectItem>)list;
                //for (int i = 0; i < list.Count(); i++)
                //{
                //    int t = dataGridViewProjectItems.Rows.Add();
                //    //dataGridViewProjectItems.Rows[t].Cells[0].Value = (list.ToArray()[i] as Model.ProjectItem).MyProduct.Manufacturer;
                //    //dataGridViewProjectItems.Rows[t].Cells[0].Value = (list.ToArray()[i] as Model.ProjectItem).MyProduct.Manufacturer;
                //    //dataGridViewProjectItems.Rows[t].Cells[0].Value = (list.ToArray()[i] as Model.ProjectItem).MyProduct.Manufacturer; 
                //    //dataGridViewProjectItems.Rows[t].Cells[0].Value = (list.ToArray()[i] as Model.ProjectItem).MyProduct.Manufacturer;
                //    //dataGridViewProjectItems.Rows[t].Cells[0].Va lue = (list.ToArray()[i] as Model.ProjectItem).MyProduct.Manufacturer;
                //    //dataGridViewProjectItems.Rows[t].Cells[0].Value = (list.ToArray()[i] as Model.ProjectItem).MyProduct.Manufacturer;
                //    //dataGridViewProjectItems.Rows[t].Cells[0].Value = (list.ToArray()[i] as Model.ProjectItem).MyProduct.Manufacturer;
                //    //这样行的
                //   // dataGridViewProjectItems.Rows[t].Cells["specificationColumn"].Value = (list.ToArray()[i] as Model.ProjectItem).MyProduct.Manufacturer;
                //}
           
               
            }
        }
        /// <summary>
        /// 查看项目
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton4_Click(object sender, EventArgs e)
        {
         
        }
        public void LoadMoney()
        {
        
            decimal productTotalMoney=new BLL.ProjectItemManager().GetProductTotalMoney(projectID);
            var model=new BLL.ProjectManager().GetByID(projectID);
            decimal projectTransportCosts=model.TransportCosts.Value;
            toolStripStatusLabel1.Text=string.Format("产品总金额:{0}",productTotalMoney);
            toolStripStatusLabel2.Text=string.Format("项目总金额:{0}",projectTransportCosts+productTotalMoney);
             
        }
        /// <summary>
        /// 修改产品
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            if (dataGridViewProjectItems.SelectedRows.Count > 0)
            {
                string sprojectItemID = dataGridViewProjectItems.SelectedRows[0].Cells["idColumn"].Value.ToString();
                int projectItemID = int.Parse(sprojectItemID);
                UpdateProjectItemForm updateProjectItemForm = new UpdateProjectItemForm();
                updateProjectItemForm.ProjectItemID = projectItemID;
                if (updateProjectItemForm.ShowDialog() == DialogResult.OK)
                {
                    LoadData();
                }

            }
        }
        /// <summary>;
        /// 删除产品是选中一行删除吗？
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            if (dataGridViewProjectItems.SelectedRows.Count>0)
            {
                string sid = dataGridViewProjectItems.SelectedRows[0].Cells["idColumn"].Value.ToString();
                if (MessageBox.Show("你确定要删除吗？", "删除", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
                {
                    if (new BLL.ProjectItemManager().DeleteByID(int.Parse(sid))>0)
                    {
                        MessageBox.Show("删除成功");
                        LoadData();
                    }
                }
            }
          
        }
    }
}
