﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Insigma.ProjectQuote.WinUI
{
    public partial class ProjectListForm : Form
    {
        public ProjectListForm()
        {
            InitializeComponent();
           
        }

        private void btnSearch_Click(object sender, EventArgs e)
        {
            dgvProjects.DataSource = new BLL.ProjectManager().GetProjectByCondition(txtProjectName.Text,txtCustomerName.Text,txtContract.Text,txtTel.Text);
        }

        private void ProjectListForm_Load(object sender, EventArgs e)
        {
            Bind();
        }
        private void Bind()
        {
            dgvProjects.DataSource=new BLL.ProjectManager().GetAll();
        }

       /// <summary>
       /// 新增操作
       /// </summary>
       /// <param name="sender"></param>
       /// <param name="e"></param>
        private void toolStripButton1_Click(object sender, EventArgs e)
        {
            AddProjectForm frm = new AddProjectForm();
            if (frm.ShowDialog()==DialogResult.OK)
            {
                //获得新增一个ID
                int newID=frm._ID;
                ProjectItemListForm projectItemListForm = new ProjectItemListForm();
                projectItemListForm.projectID = newID;
                projectItemListForm.FormBorderStyle = FormBorderStyle.None;
                projectItemListForm.TopLevel = false;
                projectItemListForm.Dock = DockStyle.Fill;
                projectItemListForm.Show();
                //获取MainForm对象：
                 Control parent=this.Parent;//获取当前窗体的父控件，即MainForm中的PanelContainer
                 parent.Controls.Clear();
                 parent.Controls.Add(projectItemListForm);
                //
                //MessageBox.Show("添加成功:)", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                //Bind();
            }
        }
        /// <summary>
        /// 修改操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton2_Click(object sender, EventArgs e)
        {
            //--------------------------------------------------------------------------
            if (dgvProjects.SelectedRows.Count>0)
            {
                string sid = dgvProjects.SelectedRows[0].Cells["idColumn"].Value.ToString();
                int projectID = int.Parse(sid);
                ProjectItemListForm projectItemListForm = new ProjectItemListForm();
                projectItemListForm.projectID = projectID;
                projectItemListForm.FormBorderStyle = FormBorderStyle.None;
                projectItemListForm.TopLevel = false;
                projectItemListForm.Dock = DockStyle.Fill;
                projectItemListForm.Show();
                projectItemListForm.SetControlsEnable();

                Control parent = this.Parent;
                parent.Controls.Clear();
                parent.Controls.Add(projectItemListForm);
            }
            //--------------------------------------------------------------------------
            
            
            //string id=dgvProjects[0,dgvProjects.CurrentRow.Index].Value.ToString();
            //AddProjectForm frm = new AddProjectForm(Convert.ToInt32(id),1);
            //if (frm.ShowDialog()==DialogResult.OK)
            //{
            //    MessageBox.Show("修改成功:)", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
            //    Bind();
            //}
        }
        /// <summary>
        /// 删除操作
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolStripButton3_Click(object sender, EventArgs e)
        {
            if (dgvProjects.SelectedRows.Count>0)
            {
               string id = dgvProjects[0, dgvProjects.CurrentRow.Index].Value.ToString();
                if (MessageBox.Show("确定要删除该项目吗？", "删除", MessageBoxButtons.YesNo, MessageBoxIcon.Information) == DialogResult.Yes)
                {
                    if (new BLL.ProjectManager().DeleteProject(Convert.ToInt32(id)))
                    {
                        MessageBox.Show("删除成功:)", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        Bind();
                        //Search();
                    }
                    else
                    {
                        MessageBox.Show("删除失败");
                    }
                }
            }
 
        }
        //1.算钱
        //2.添加一个查看项目
        //3.删除项目,先删..项目相关的产品
        //
        private void toolStripButton4_Click(object sender, EventArgs e)
        {
            if (dgvProjects.SelectedRows.Count > 0)
            {
                string sid = dgvProjects.SelectedRows[0].Cells["idColumn"].Value.ToString();
                int projectID = int.Parse(sid);
                ProjectItemListForm projectItemListForm = new ProjectItemListForm();
                projectItemListForm.projectID = projectID;
                projectItemListForm.FormBorderStyle = FormBorderStyle.None;
                projectItemListForm.TopLevel = false;
                projectItemListForm.Dock = DockStyle.Fill;
                projectItemListForm.Show();
                projectItemListForm.SetControlsDisable();

                Control parent = this.Parent;
                parent.Controls.Clear();
                parent.Controls.Add(projectItemListForm);
            }
        }
    }
}
