﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Insigma.ProjectQuote.WinUI
{
    public partial class UpdateProjectItemForm : Form
    {
        public int ProjectItemID = -1;
        public int ProjectID = -1;
        public int ProductID = -1;
        public UpdateProjectItemForm()
        {
            InitializeComponent();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            Model.ProjectItem model = new Model.ProjectItem();
            Model.Product modelProduct = new Model.Product();
            model._Project = new Model.Project();
            model._Product = modelProduct;
            model._Product.ID = this.ProductID;
            model._Project.ID = this.ProjectID;
            model.ID = ProjectItemID;
            try
            {
                model.UnitPrice = decimal.Parse(txtPrice.Text);
            }
            catch
            {
                MessageBox.Show("请输入合法数值");
                return;
            }
            model._Product.Specification = labSpecification.Text;
            try
            {
                model.Count = int.Parse(txtUnitCount.Text);
            }
            catch
            {
                MessageBox.Show("请输入合法的数量");
                return;
            }
            model.TotalMoney = model.Count * model.UnitPrice;
            if (new BLL.ProjectItemManager().Update(model)>0)//可以在BLL
            {
                MessageBox.Show("更新成功");
                this.DialogResult = DialogResult.OK;
            }
            ////ProjectItemBLL bll = new ProjectItemBLL();
            //try
            //{
            //    if (bll。AddProjectForm(ProjectID,))
            //    {

            //    }
            //}
            //catch (Exception)
            //{

            //    throw;
            //}
        }

        private void UpdateProjectItemForm_Load(object sender, EventArgs e)
        {
            //这里需要关联查询，先省略...
            var model = new BLL.ProjectItemManager().GetOneProjectItemByID(ProjectItemID);
            if (model!=null)
            {
                ProjectID = model._Project.ID;
                ProductID = model._Product.ID;
                txtPrice.Text = model.UnitPrice.ToString();
                txtProductName.Text = model._Product.ProductName;
                txtUnitCount.Text = model.Count.ToString();
                labManufacturer.Text = model._Product.Manufacturer;
                labParameters.Text = model._Product.Parameters;
                labSpecification.Text = model._Product.Specification;
                labUnit.Text = model._Product.Unit;
            }
        }

        private void btnSelect_Click(object sender, EventArgs e)
        {
            SearchProductForm searchProductForm = new SearchProductForm();
            if (searchProductForm.ShowDialog() == DialogResult.OK)
            {
                ProductID = searchProductForm.SelectedProductID;
                var model = new BLL.ProductManager().GetByID(ProductID);
                txtPrice.Text = model.Price.ToString();
                txtProductName.Text = model.ProductName;
                labManufacturer.Text = model.Manufacturer;
                labParameters.Text = model.Parameters;
                labSpecification.Text = model.Specification;
                labUnit.Text = model.Unit;

            }
        }
    }
}
